--[[
 Halo 3 & Halo 4 © Microsoft Corporation. Killing Streaks was created under Microsoft's "Game Content Usage Rules" using assets from Halo 3 & Halo 4. It is not endorsed by Microsoft and does not reflect the views or opinions of Microsoft or anyone officially involved in producing or managing Halo 3 and/or Halo 4.  As such, it does not contribute to the official narrative of the fictional universe, if applicable.
 
 Used with permission from Microsoft.
 
 Required Link to Rules:
 http://www.xbox.com/en-US/Community/Developer/Rules
]]

local HKSF = CreateFrame("Frame")

LibStub("AceTimer-3.0"):Embed(HKSF)
LibStub("AceEvent-3.0"):Embed(HKSF)
LibStub("AceConsole-3.0"):Embed(HKSF)

local killcount = 0
local killstreak = 0
local TimerHandle

function HKSF:StreakEnded()
	if killcount >= 2 then
		print("\124cFFFF0000Timed Killing Streak Ended")
	end
	killcount = 0
end

function HKSF:Input(arg1)
	--print("Debug:"..arg1)
	ksArg1, ksArg2, ksArg3, ksArg4 = HKSF:GetArgs(arg1, 4, 1) 
	if ksArg1 ~= nil then
		-- We have arguments to work with... Lets sort them out:
		if string.lower(ksArg1) == "test" then
			if string.lower(ksArg2) == "ks" then
				-- Play KillStreak sound for the given number
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..ksArg3..".mp3");
				PlaySoundFile(soundfile,KS_Channel)
			elseif string.lower(ksArg2) == "kc" then
				-- Play Killcount sound for the given number
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..ksArg3..".mp3");
				PlaySoundFile(soundfile,KS_Channel)
			elseif string.lower(ksArg2) == "killstreak" then
				print(killstreak)
			elseif string.lower(ksArg2) == "killstreakrecord" then
				print(KillStreakRecord)
			end
		elseif string.lower(ksArg1) == "killstreak" then
			if string.lower(ksArg2) == "show" then
				if string.lower(ksArg3) == "streak" then
					print("Current Killstreak Count: "..killstreak)
				elseif string.lower(ksArg3) == "record" then
					print("Current Killstreak Record: "..KillStreakRecord)
				end
			elseif string.lower(ksArg2) == "report" then
				local _record
				if KillStreakRecord > killstreak then
					_record = KillStreakRecord
				else
					_record = killstreak
				end
				-- Print based on channel included in ksArg3(3rd command)
				if string.lower(ksArg3) == "say" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "SAY", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "party" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "PARTY", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "guild" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "GUILD", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "raid" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "RAID", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "bg" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "BATTLEGROUND", GetDefaultLanguage("player")	, nil)
				elseif string.lower(ksArg3) == "whisper" then
					SendChatMessage(UnitName("player").." has a killstreak of: ".._record.." kills.", "WHISPER", nil, ksArg4)
				end
			end
		elseif string.lower(ksArg1) == "reset" then
			killstreak = 0
			print("Killstreak Reset")
		end
	end
end

function CheckKillsPlaySound(killcount, killstreak)
	blank = "Interface\\AddOns\\KillingStreaks\\Blank\\Blank.mp3"
	if killcount > 1 then
		if HKSF:TimeLeft(TimerHandle) > 0 then
			if killcount == 2 then
				-- Double Kill | 2 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDDouble Kill!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 3 then
				-- Triple Kill | 3 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDTriple Kill!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 4 then
				-- Overkill | 4 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDOverkill!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 5 then
				-- Killtacular | 5 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltacular!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 6 then
				-- Killtrocity | 6 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltrocity!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 7 then
				-- Killimanjaro | 7 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillimanjaro!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 8 then
				-- Killtastrophe | 8 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKilltastrophe!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 9 then
				-- Killpocalypse | 9 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillpocalypse!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			elseif killcount == 10 then
				-- Killionaire | 10 kills within 4 seconds of each other.
				local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Timed\\"..killcount..".mp3");
				print("\124cFF79CDCDKillionaire!")
				PlaySoundFile(blank,KS_Channel)
				PlaySoundFile(soundfile,KS_Channel)
			end
		end
	elseif killstreak > 1 and HKSF:TimeLeft(TimerHandle) > 0 then
		if killstreak == 5 then
			-- Killing Spree | Kill 5 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Spree!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 10 then
			-- Killing Frenzy | Kill 10 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDKilling Frenzy!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 15 then
			-- Running Riot | Kill 15 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRunning Riot!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 20 then
			-- Rampage | Kill 20 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDRampage!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 25 then
			-- Untouchable | Kill 25 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUntouchable!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 30 then
			-- Invincible | Kill 30 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInvincible!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 35 then
			-- Inconceivable | Kill 35 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDInconceivable!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		elseif killstreak == 40 then
			-- Unfriggenbelievable | Kill 40 enemies without dying.
			local soundfile = tostring("Interface\\AddOns\\KillingStreaks\\Streak\\"..killstreak..".mp3");
			print("\124cFF79CDCDUnfriggenbelievable!")
			PlaySoundFile(blank,KS_Channel)
			PlaySoundFile(soundfile,KS_Channel)
		end
	end
end

function HKSF:OnCombatEvent(eventName, timestamp, event, _, sourceGUID, sourceName, _, _, destGUID, destName)
	--print("Event Name:"..eventName.." | Subevent:"..event.." | Killcount:"..killcount.." | Killstreak:"..killstreak)
	-- Debug:
	--[[if event == "PARTY_KILL" then
		print("Dest GUID:"..destGUID..", Source GUID:"..sourceGUID..",Event:"..event..", Player GUID:"..UnitGUID("player"))
	end]]
	if (event == "PARTY_KILL" and sourceGUID == UnitGUID("player")) then
		HKSF:CancelTimer(TimerHandle)
		TimerHandle = HKSF:ScheduleTimer("StreakEnded", 4)
		killcount = killcount + 1
		killstreak = killstreak + 1
		CheckKillsPlaySound(killcount, killstreak)
	elseif (event == "UNIT_DIED" and UnitIsDeadOrGhost("player") == 1 and destGUID == UnitGUID("player")) then
		print("Killing Streak Ended")
		if killstreak > KillStreakRecord then
			-- New Kill Record. Save it for bragging rights.
			KillStreakRecord = killstreak
			print("New Streak Record of "..killstreak.." kills.")
		end
		killstreak = 0
	end
end

function HKSF:OnEnterWorld(event, arg1, ...)
	if arg1 == "KillingStreaks" then
		if KillStreakRecord == nil then
			-- First time loading addon
			KillStreakRecord = 0
		end
		print("Killing Streaks Loaded")
	end
end

HKSF:RegisterChatCommand("ks", "Input", true);
HKSF:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent");
HKSF:RegisterEvent("ADDON_LOADED", "OnEnterWorld");
--HKSF:SetScript("OnEvent", function(timestamp, event, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

